// 
// ABSReader.h : Read a FRGC 2D depth map (.abs) 
//
// Copyright (C) 2010  Clement Creusot
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ABSREADERH
#define ABSREADERH

#include "vtkPolyDataAlgorithm.h"

class VTK_IO_EXPORT ABSReader : public vtkPolyDataAlgorithm 
{
public:
  static ABSReader *New();
  vtkTypeRevisionMacro(ABSReader,vtkPolyDataAlgorithm);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Specify file name of Wavefront .obj file.
  vtkSetStringMacro(FileName);
  vtkGetStringMacro(FileName);

  vtkSetMacro(reductionFactor, int);

protected:
  ABSReader();
  ~ABSReader();
  
  int RequestData(vtkInformation *, vtkInformationVector **, vtkInformationVector *);

  char *FileName;
  int reductionFactor;
private:
  ABSReader(const ABSReader&);  // Not implemented.
  void operator=(const ABSReader&);  // Not implemented.
};

#endif
